/*
 * Copyright (c) 1997 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 *
 * Copyright (c) 1997 Dug Song <dugsong@UMICH.EDU>
 *                    Nathan Binkert <binkertn@UMICH.EDU>
 *                    Jim Simpson <freyjs@UMICH.EDU>
 *
 * All rights reserved, all wrongs reversed.
 * Disclaimer: i claim dis
 */

#ifndef _NPKRB4_H
#define _NPKRB4_H

#ifdef WIN32
#define XP_WIN32
#define XP_WINDOWS
#endif /* WIN32 */

#ifdef WIN16
#define XP_WIN16
#define XP_WINDOWS
#endif /* WIN16 */

/* Kerberos includes. */
#if defined(XP_UNIX)

#include <krb.h>
#include <des.h>

#elif defined(XP_WIN32)

#include "kerberos.h"
#include "des32.h"
#define MAX_KTXT_LEN 1250
#define ANAME_SZ KRB_SERVICE_SZ
#define INST_SZ KRB_INSTANCE_SZ
#define REALM_SZ KRB_REALM_SZ
#define MAX_K_NAME_SZ	(2*ANAME_SZ + 2*INST_SZ + 2*REALM_SZ - 3)

#elif defined(__MWERKS__)

#include "authLibrary.h"
/* MIT Kerberos defs. */
#define ANAME_SZ 128
#define INST_SZ 128
#define REALM_SZ 128

#endif /* XP_UNIX || _WIN32 || __MWERKS__ */


#if defined (__MWERKS__) || defined(XP_WIN32)
#define URL_SZ 1024
#define DATA_SZ 2048

struct ktext {
  long length;                       /* Length of the text */
  unsigned char dat[MAX_KTXT_LEN];  /* The data itself */
  unsigned long mbz;                /* zero to catch runaway strings */
};

typedef struct ktext *KTEXT;
typedef struct ktext KTEXT_ST;

typedef unsigned char des_cblock[8];
#define C_Block des_cblock
#define DES_KEY_SZ (sizeof(des_cblock))
#endif /* __MWERKS__ || XP_WIN32 */

/* Externally defined functions in HTUU.c and md5.c. */
#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */
int uuencode(unsigned char *bufin, unsigned int nbytes, char *bufcoded);

void hmac_md5(unsigned char *text, int tlen,
	      unsigned char *key, int klen, char *dest);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _NPKRB4_H */
